package xyz.lychee.lagfixer.libs.adventure.text.minimessage.internal.serializer;

import xyz.lychee.lagfixer.libs.adventure.text.Component;
import xyz.lychee.lagfixer.libs.annotations.NotNull;

public interface TokenEmitter {
   @NotNull TokenEmitter tag(final @NotNull String token);

   @NotNull TokenEmitter selfClosingTag(final @NotNull String token);

   default @NotNull TokenEmitter arguments(final String... args) {
      String[] var2 = args;
      int var3 = args.length;

      for(int var4 = 0; var4 < var3; ++var4) {
         String arg = var2[var4];
         this.argument(arg);
      }

      return this;
   }

   @NotNull TokenEmitter argument(final @NotNull String arg);

   @NotNull TokenEmitter argument(final @NotNull String arg, final @NotNull QuotingOverride quotingPreference);

   @NotNull TokenEmitter argument(final @NotNull Component arg);

   @NotNull TokenEmitter text(final @NotNull String text);

   @NotNull TokenEmitter pop();
}
